
//	This source and fast ascii text file indexing method apply to GNU General Public License. 
//			Copyright (C) 2007-2014 Jasenko Dzinleski 

//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version. 

//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details. 

//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

//
//			ASCII Text File Indexing Routine
//			written by Dzinleski Jasenko 2007-2014
//


#include <stdio.h>
#include <string.h>
#include <vector>
#include <iostream>

char	infn[255]="book_sd.txt";

FILE	*f1;

using std::vector; vector<long> lp;
int	lpc1=256;
int	lpi=0;

using std::vector; vector<vector<long> > lz;
int	lzc1=256;
int	lzc2=4;
int	lzi=0;

using std::vector; vector<vector<long> > pos;

int	lposc1=256;
int	lposc2=256;

using std::vector; vector<vector<long> > pos3;

int	lpos3c1=256;
int	lpos3c2=256;

using std::vector; vector<vector<long> > pos5;

int	lpos5c1=256;
int	lpos5c2=256;

int	ba161[16][16][16][16];
int	ba163[16][16][16][16];
int	ba165[16][16][16][16];

int	posi=0;
int	posi3=0;
int	posi5=0;

bool	df=false;

int	msort_3()
{

	int	i,j,k,l,m,n,o,p,r,q;
	int	i3,j3,k3,l3;
	int	i5,j5,k5,l5;

	int	a,b,c,d;
	int	ah,al,bh,bl;
	int	ah3,al3,bh3,bl3;
	int	ah5,al5,bh5,bl5;

	long	ln;
	long	ppos;

	char	fbyte;

	lp.resize(lpc1);
	lz.resize(lzc1);for(i=0;i<lzc1;++i){lz[i].resize(lzc2);}

	f1=fopen(infn,"rb");

	fbyte=getc(f1);
	while(!feof(f1))
	{
		//printf("%c",fbyte);
		c=1;ppos=-1+ftell(f1);while(!feof(f1)&&(int)fbyte!=13&&(int)fbyte!=10){fbyte=getc(f1);++c;}
		while(((int)fbyte==13||(int)fbyte==10)&&!feof(f1)){fbyte=getc(f1);}if(feof(f1)){break;}
		if(c>6){lp[lpi]=ppos;++lpi;}
		if(lpi>=lpc1){j=0;while(lpi>=(j+lpc1)){j+=2;}i=lpc1;lpc1+=j;lp.resize(lpc1);}
	}	
	fclose(f1);

	f1=fopen(infn,"rb");
	for(i=0;i<lpi;++i)
	{
		
		fseek(f1,lp[i],SEEK_SET);

		lz[lzi][0]=lp[i];
		fbyte=getc(f1);n=fbyte;fbyte=getc(f1);lz[lzi][1]=(n<<8)|fbyte;
		fbyte=getc(f1);n=fbyte;fbyte=getc(f1);lz[lzi][2]=(n<<8)|fbyte;
		fbyte=getc(f1);n=fbyte;fbyte=getc(f1);lz[lzi][3]=(n<<8)|fbyte;
		++lzi;
		if(lzi>=lzc1)
		{
			a=0;while(lzi>=(a+lzc1)){a+=2;}
			b=lzc1;lzc1+=a;lz.resize(lzc1);
			for(a=b;a<lzc1;++a){lz[a].resize(lzc2);}
		}
	}
	fclose(f1);

	pos.resize(lposc1);for(i=0;i<lposc1;++i){pos[i].resize(lposc2);}
	for(i=0;i<lposc1;++i){pos[i][0]=lposc2;pos[i][1]=1;}

	for(i=0;i<16;++i){for(j=0;j<16;++j){for(k=0;k<16;++k){for(l=0;l<16;++l)
	{
		ba161[i][j][k][l]=-1;
	}}}}

	posi=0;
	for(a=0;a<lzi;++a)
	{
		ah=(lz[a][1]&0x0000f000)>>12;
		al=(lz[a][1]&0x00000f00)>>8;

		bh=(lz[a][1]&0x000000f0)>>4;
		bl=(lz[a][1]&0x0000000f)>>0;

		if(ba161[ah][al][bh][bl]==-1)
		{
			ba161[ah][al][bh][bl]=posi;

			if(ba161[ah][al][bh][bl]>=lposc1)
			{
			j=0;while(ba161[ah][al][bh][bl]>=(j+lposc1)){j+=2;}
			i=lposc1;lposc1+=j;pos.resize(lposc1);
			for(j=i;j<lposc1;++j){pos[j].resize(lposc2);}
			for(j=i;j<lposc1;++j){pos[j][0]=lposc2;pos[j][1]=1;}			
			}	

			++pos[ba161[ah][al][bh][bl]][1];

			if(pos[ba161[ah][al][bh][bl]][1]>=pos[ba161[ah][al][bh][bl]][0])
			{
			j=0;while(pos[ba161[ah][al][bh][bl]][1]>=(j+pos[ba161[ah][al][bh][bl]][0])){j+=2;}
			pos[ba161[ah][al][bh][bl]][0]+=j;
			pos[ba161[ah][al][bh][bl]].resize(pos[ba161[ah][al][bh][bl]][0]);
			}

			pos[ba161[ah][al][bh][bl]][pos[ba161[ah][al][bh][bl]][1]]=a;
			++pos[ba161[ah][al][bh][bl]][1];
			++posi;

		}else{

			if(pos[ba161[ah][al][bh][bl]][1]>=pos[ba161[ah][al][bh][bl]][0])
			{
			j=0;while(pos[ba161[ah][al][bh][bl]][1]>=(j+pos[ba161[ah][al][bh][bl]][0])){j+=2;}
			pos[ba161[ah][al][bh][bl]][0]+=j;
			pos[ba161[ah][al][bh][bl]].resize(pos[ba161[ah][al][bh][bl]][0]);
			}

			pos[ba161[ah][al][bh][bl]][pos[ba161[ah][al][bh][bl]][1]]=a;
			++pos[ba161[ah][al][bh][bl]][1];

		}
	}

	f1=fopen(infn,"rb");
	for(i=0;i<16;++i){for(j=0;j<16;++j){for(k=0;k<16;++k){for(l=0;l<16;++l)
	{
		if(ba161[i][j][k][l]!=-1)
		{
			if(pos[ba161[i][j][k][l]][1]==2)
			{
				fseek(f1,lz[pos[ba161[i][j][k][l]][1]][0],SEEK_SET);
				fbyte=getc(f1);
				while(!feof(f1)&&(int)fbyte!=10&&(int)fbyte!=13){printf("%c",fbyte);fbyte=getc(f1);}printf("\n");							
				continue;
			}

			lpos3c1=256;
			pos3.resize(lpos3c1);for(a=0;a<lpos3c1;++a){pos3[a].resize(lpos3c2);}
			for(a=0;a<lpos3c1;++a){pos3[a][0]=lpos3c2;pos3[a][1]=1;}

			for(i3=0;i3<16;++i3){for(j3=0;j3<16;++j3){for(k3=0;k3<16;++k3){for(l3=0;l3<16;++l3)
			{
				ba163[i3][j3][k3][l3]=-1;
			}}}}

			posi3=0;
			for(o=2;o<pos[ba161[i][j][k][l]][1];++o)
			{

				ah3=(lz[pos[ba161[i][j][k][l]][o]][1]&0x000000f0)>>4;
				al3=(lz[pos[ba161[i][j][k][l]][o]][1]&0x0000000f)>>0;

				bh3=(lz[pos[ba161[i][j][k][l]][o]][2]&0x0000f000)>>12;
				bl3=(lz[pos[ba161[i][j][k][l]][o]][2]&0x00000f00)>>8;

				if(ba163[ah3][al3][bh3][bl3]==-1)
				{

				ba163[ah3][al3][bh3][bl3]=posi3;	

				if(ba163[ah3][al3][bh3][bl3]>=lpos3c1)
				{
				a=0;while(ba163[ah3][al3][bh3][bl3]>=(a+lpos3c1)){a+=2;}
				b=lpos3c1;lpos3c1+=a;pos3.resize(lpos3c1);
				for(a=b;a<lpos3c1;++a){pos3[a].resize(lpos3c2);}
				for(a=b;a<lpos3c1;++a){pos3[a][0]=lpos3c1;pos3[a][1]=1;}		
				}
	
				++pos3[ba163[ah3][al3][bh3][bl3]][1];

				if(pos3[ba163[ah3][al3][bh3][bl3]][1]>=pos3[ba163[ah3][al3][bh3][bl3]][0])
				{
				a=0;while(pos3[ba163[ah3][al3][bh3][bl3]][1]>=(a+pos3[ba163[ah3][al3][bh3][bl3]][0])){a+=2;}
				pos3[ba163[ah3][al3][bh3][bl3]][0]+=a;
				pos3[ba163[ah3][al3][bh3][bl3]].resize(pos3[ba163[ah3][al3][bh3][bl3]][0]);
				}

				pos3[ba163[ah3][al3][bh3][bl3]][pos3[ba163[ah3][al3][bh3][bl3]][1]]=pos[ba161[i][j][k][l]][o];
				++pos3[ba163[ah3][al3][bh3][bl3]][1];
				++posi3;
					
				}else{
					
					if(pos3[ba163[ah3][al3][bh3][bl3]][1]>=pos3[ba163[ah3][al3][bh3][bl3]][0])
					{
					a=0;while(pos3[ba163[ah3][al3][bh3][bl3]][1]>=(a+pos3[ba163[ah3][al3][bh3][bl3]][0])){a+=2;}
					pos3[ba163[ah3][al3][bh3][bl3]][0]+=a;
					pos3[ba163[ah3][al3][bh3][bl3]].resize(pos3[ba163[ah3][al3][bh3][bl3]][0]);
					}

					pos3[ba163[ah3][al3][bh3][bl3]][pos3[ba163[ah3][al3][bh3][bl3]][1]]=pos[ba161[i][j][k][l]][o];
					++pos3[ba163[ah3][al3][bh3][bl3]][1];
					
				}
			}

			for(i3=0;i3<16;++i3){for(j3=0;j3<16;++j3){for(k3=0;k3<16;++k3){for(l3=0;l3<16;++l3)
			{
				if(ba163[i3][j3][k3][l3]!=-1)
				{
					if(pos3[ba163[i3][j3][k3][l3]][1]==2)
					{
						fseek(f1,lz[pos3[ba163[i3][j3][k3][l3]][1]][0],SEEK_SET);
						fbyte=getc(f1);
						while(!feof(f1)&&(int)fbyte!=10&&(int)fbyte!=13){printf("%c",fbyte);fbyte=getc(f1);}printf("\n");							
						continue;
					}

					lpos5c1=256;
					pos5.resize(lpos5c1);for(a=0;a<lpos5c1;++a){pos5[a].resize(lpos5c2);}
					for(a=0;a<lpos3c1;++a){pos5[a][0]=lpos3c1;pos5[a][1]=1;}

					for(i5=0;i5<16;++i5){for(j5=0;j5<16;++j5){for(k5=0;k5<16;++k5){for(l5=0;l5<16;++l5)
					{
						ba165[i5][j5][k5][l5]=-1;
					}}}}

					posi5=0;
					for(o=2;o<pos3[ba163[i3][j3][k3][l3]][1];++o)
					{
		
					ah5=(lz[pos3[ba163[i3][j3][k3][l3]][o]][2]&0x000000f0)>>4;
					al5=(lz[pos3[ba163[i3][j3][k3][l3]][o]][2]&0x0000000f)>>0;

					bh5=(lz[pos3[ba163[i3][j3][k3][l3]][o]][3]&0x0000f000)>>12;
					bl5=(lz[pos3[ba163[i3][j3][k3][l3]][o]][3]&0x00000f00)>>8;

					if(ba165[ah5][al5][bh5][bl5]==-1)
					{

					ba165[ah5][al5][bh5][bl5]=posi5;	

					if(ba165[ah5][al5][bh5][bl5]>=lpos5c1)
					{
					a=0;while(ba165[ah5][al5][bh5][bl5]>=(a+lpos5c1)){a+=2;}
					b=lpos5c1;lpos5c1+=a;pos5.resize(lpos5c1);
					for(a=b;a<lpos5c1;++a){pos5[a].resize(lpos5c2);}
					for(a=b;a<lpos5c1;++a){pos5[a][0]=lpos5c2;pos5[a][1]=1;}			
					}	

					++pos5[ba165[ah5][al5][bh5][bl5]][1];

					if(pos5[ba165[ah5][al5][bh5][bl5]][1]>=pos5[ba165[ah5][al5][bh5][bl5]][0])
					{
					a=0;while(pos5[ba165[ah5][al5][bh5][bl5]][1]>=(a+pos5[ba165[ah5][al5][bh5][bl5]][0])){a+=2;}
					pos5[ba165[ah5][al5][bh5][bl5]][0]+=a;
					pos5[ba165[ah5][al5][bh5][bl5]].resize(pos5[ba165[ah5][al5][bh5][bl5]][0]);
					}

					pos5[ba165[ah5][al5][bh5][bl5]][pos5[ba165[ah5][al5][bh5][bl5]][1]]=pos3[ba163[i3][j3][k3][l3]][o];
					++pos5[ba165[ah5][al5][bh5][bl5]][1];
					++posi5;

					}else{
							
						if(pos5[ba165[ah5][al5][bh5][bl5]][1]>=pos5[ba165[ah5][al5][bh5][bl5]][0])
						{
						a=0;while(pos5[ba165[ah5][al5][bh5][bl5]][1]>=(a+pos5[ba165[ah5][al5][bh5][bl5]][0])){a+=2;}
						pos5[ba165[ah5][al5][bh5][bl5]][0]+=a;
						pos5[ba165[ah5][al5][bh5][bl5]].resize(pos5[ba165[ah5][al5][bh5][bl5]][0]);
						}

						pos5[ba165[ah5][al5][bh5][bl5]][pos5[ba165[ah5][al5][bh5][bl5]][1]]=pos3[ba163[i3][j3][k3][l3]][o];
						++pos5[ba165[ah5][al5][bh5][bl5]][1];

					}
				}

				for(i5=0;i5<16;++i5){for(j5=0;j5<16;++j5){for(k5=0;k5<16;++k5){for(l5=0;l5<16;++l5)
				{
					if(ba165[i5][j5][k5][l5]!=-1)
					{
						for(m=2;m<pos5[ba165[i5][j5][k5][l5]][1];++m)
						{
							fseek(f1,lz[pos5[ba165[i5][j5][k5][l5]][m]][0],SEEK_SET);
							fbyte=getc(f1);
							while(!feof(f1)&&(int)fbyte!=10&&(int)fbyte!=13){printf("%c",fbyte);fbyte=getc(f1);}printf("\n");
						}
					}
				}}}}
			}
		}}}}
	}
}}}}		
fclose(f1);

return(0);

}

int main(int argc,char *argv[])
{
	int		i,l,j,k,m;
	int		a;
	char		cmd[255];

	printf("\nASCII Text File Fast Sort/Indexing Routine\n");
	printf("written by Dzinleski Jasenko January , 2014\n");
	printf("\nOS Win32 VRM 1.4.0\n\n");

	for(i=1;i<argc;++i)
	{
		if(strlen(argv[i])>0)
		{
			for(j=0;j<255;++j){cmd[j]='\0';}
			strcpy(cmd,argv[i]);

			if(cmd[0]=='-'&&strlen(cmd)==2)
			{
				if(cmd[1]=='f')
				{
					for(j=0;j<50;++j){infn[j]='\0';}
					strcpy(infn,argv[i+1]);

					f1=fopen(infn,"rb");
					if(f1!=NULL)
					{
						fclose(f1);

						//printf(" %s %d",infn,ws[ind]);
						//printf(" %s %s %d",infn,ws[1],wsi[1]);
						//printf(" %s %s %d",infn,ws[2],wsi[2]);

						msort_3();
						break;

					}else{printf("No file!");}
					break;
				}else{
					if(cmd[1]=='h')
					{

						printf("\nASCII Text File Fast Sort/Indexing Routine\n");
						printf("written by Dzinleski Jasenko January , 2014\n");
						printf("\nOS Win32 VRM 1.4.0\n\n");
						printf("\n");
						printf("msort3 -f <filename to sort>\n");
						printf("\n");
						break;

					}else{
						if(cmd[1]=='l'||cmd[1]=='e')
						{	

							printf("\nASCII Text File Fast Sort/Indexing Routine\n");
							printf("written by Dzinleski Jasenko January , 2014\n");
							printf("\nOS Win32 VRM 1.4.0\n\n");
							printf("\n");
							printf("\tThis source and fast ascii text file sorting/indexing method apply to GNU General Public License.\n");
							printf("\t		Copyright (C) 2007-2014 Jasenko Dzinleski \n");
							printf("\n");
							printf("\t	This program is free software; you can redistribute it\n");
							printf("\tand/or modify it under the terms of the GNU General Public License as\n");
							printf("\tpublished by the Free Software Foundation; either version 2 of the\n");
							printf("\tLicense, or (at your option) any later version.\n");
							printf("\n");
							printf("\tThis program is distributed in the hope that it will be useful, but\n");
							printf("\tWITHOUT ANY WARRANTY; without even the implied warranty of\n");
							printf("\tMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n");
							printf("\tGeneral Public License for more details.\n");
							printf("\n");
							printf("\tYou should have received a copy of the GNU General Public License along\n");
							printf("\twith this program; if not, write to the Free Software Foundation, Inc.,\n");
							printf("\t51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.\n");
							printf("\n");
							break;

						}
					}
				}
			}
		}
	}

	return(0);
}
